# swagger_client

SwaggerClient - the Ruby gem for the APIs.io Search API

This is the API behind the APIs.io search engine.

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: V1
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.ruby.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build swagger_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./swagger_client-1.0.0.gem
```
(for development, run `gem install --dev ./swagger_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'swagger_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'swagger_client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'swagger_client'
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: api_key
  config.api_key['x-api-key'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['x-api-key'] = 'Bearer'
end

api_instance = SwaggerClient::SearchApi.new
body = SwaggerClient::APIsJSON.new # APIsJSON | 


begin
  #Submit API
  result = api_instance.add_api(body)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling SearchApi->add_api: #{e}"
end

api_instance = SwaggerClient::SearchApi.new
opts = { 
  search: 'search_example', # String | Keyword to search by.
  type: 'type_example', # String | Type to search by.
  maintainer: 'maintainer_example', # String | Maintainer to search by.
  limit: 'limit_example', # String | 
  page: 'page_example' # String | 
}

begin
  #Search APIs
  result = api_instance.search_apis(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling SearchApi->search_apis: #{e}"
end

api_instance = SwaggerClient::SearchApi.new
opts = { 
  search: 'search_example', # String | Keyword to search by.
  limit: 'limit_example', # String | 
  page: 'page_example' # String | 
}

begin
  #Search Maintainers
  result = api_instance.search_maintainers(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling SearchApi->search_maintainers: #{e}"
end
```

## Documentation for API Endpoints

All URIs are relative to *https://ibmwu99rx3.execute-api.us-east-1.amazonaws.com/staging*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SwaggerClient::SearchApi* | [**add_api**](docs/SearchApi.md#add_api) | **POST** /search/apis | Submit API
*SwaggerClient::SearchApi* | [**search_apis**](docs/SearchApi.md#search_apis) | **GET** /search/apis | Search APIs
*SwaggerClient::SearchApi* | [**search_maintainers**](docs/SearchApi.md#search_maintainers) | **GET** /search/maintainers | Search Maintainers

## Documentation for Models

 - [SwaggerClient::API](docs/API.md)
 - [SwaggerClient::APIsJSON](docs/APIsJSON.md)
 - [SwaggerClient::AnyOfSearchDataItems](docs/AnyOfSearchDataItems.md)
 - [SwaggerClient::Contact](docs/Contact.md)
 - [SwaggerClient::DiagnosticSeverity](docs/DiagnosticSeverity.md)
 - [SwaggerClient::Format](docs/Format.md)
 - [SwaggerClient::Formats](docs/Formats.md)
 - [SwaggerClient::Given](docs/Given.md)
 - [SwaggerClient::HumanReadableSeverity](docs/HumanReadableSeverity.md)
 - [SwaggerClient::Include](docs/Include.md)
 - [SwaggerClient::Latest](docs/Latest.md)
 - [SwaggerClient::LatestProperties](docs/LatestProperties.md)
 - [SwaggerClient::LatestPropertiesRules](docs/LatestPropertiesRules.md)
 - [SwaggerClient::LatestRules](docs/LatestRules.md)
 - [SwaggerClient::Maintainer](docs/Maintainer.md)
 - [SwaggerClient::MetaInformation](docs/MetaInformation.md)
 - [SwaggerClient::ModelThen](docs/ModelThen.md)
 - [SwaggerClient::PathExpression](docs/PathExpression.md)
 - [SwaggerClient::Property](docs/Property.md)
 - [SwaggerClient::PublishAPIs](docs/PublishAPIs.md)
 - [SwaggerClient::PublishMaintainers](docs/PublishMaintainers.md)
 - [SwaggerClient::PublishProperties](docs/PublishProperties.md)
 - [SwaggerClient::PublishTags](docs/PublishTags.md)
 - [SwaggerClient::Rule](docs/Rule.md)
 - [SwaggerClient::Search](docs/Search.md)
 - [SwaggerClient::SearchLinks](docs/SearchLinks.md)
 - [SwaggerClient::SearchMeta](docs/SearchMeta.md)
 - [SwaggerClient::Severity](docs/Severity.md)
 - [SwaggerClient::Tag](docs/Tag.md)
 - [SwaggerClient::UpdateMaintainers](docs/UpdateMaintainers.md)
 - [SwaggerClient::UpdateProperties](docs/UpdateProperties.md)
 - [SwaggerClient::UpdateTags](docs/UpdateTags.md)

## Documentation for Authorization


### api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header

