=begin
#APIs.io Search API

#This is the API behind the APIs.io search engine.

OpenAPI spec version: V1
Contact: info@apievangelist.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.51
=end

module SwaggerClient
  class SearchApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Submit API
    # Submit an API to be included in the index.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [APIsJSON]
    def add_api(body, opts = {})
      data, _status_code, _headers = add_api_with_http_info(body, opts)
      data
    end

    # Submit API
    # Submit an API to be included in the index.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(APIsJSON, Integer, Hash)>] APIsJSON data, response status code and response headers
    def add_api_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: SearchApi.add_api ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling SearchApi.add_api"
      end
      # resource path
      local_var_path = '/search/apis'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'APIsJSON' 

      auth_names = opts[:auth_names] || ['api_key']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SearchApi#add_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Search APIs
    # Searching across all APIs by keyword, property type, or maintainer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Keyword to search by.
    # @option opts [String] :type Type to search by.
    # @option opts [String] :maintainer Maintainer to search by.
    # @option opts [String] :limit 
    # @option opts [String] :page 
    # @return [Search]
    def search_apis(opts = {})
      data, _status_code, _headers = search_apis_with_http_info(opts)
      data
    end

    # Search APIs
    # Searching across all APIs by keyword, property type, or maintainer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Keyword to search by.
    # @option opts [String] :type Type to search by.
    # @option opts [String] :maintainer Maintainer to search by.
    # @option opts [String] :limit 
    # @option opts [String] :page 
    # @return [Array<(Search, Integer, Hash)>] Search data, response status code and response headers
    def search_apis_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: SearchApi.search_apis ...'
      end
      # resource path
      local_var_path = '/search/apis'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'type'] = opts[:'type'] if !opts[:'type'].nil?
      query_params[:'maintainer'] = opts[:'maintainer'] if !opts[:'maintainer'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Search' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SearchApi#search_apis\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Search Maintainers
    # Search across all maintainers.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Keyword to search by.
    # @option opts [String] :limit 
    # @option opts [String] :page 
    # @return [Search]
    def search_maintainers(opts = {})
      data, _status_code, _headers = search_maintainers_with_http_info(opts)
      data
    end

    # Search Maintainers
    # Search across all maintainers.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Keyword to search by.
    # @option opts [String] :limit 
    # @option opts [String] :page 
    # @return [Array<(Search, Integer, Hash)>] Search data, response status code and response headers
    def search_maintainers_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: SearchApi.search_maintainers ...'
      end
      # resource path
      local_var_path = '/search/maintainers'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Search' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SearchApi#search_maintainers\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
